'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _SVGPrev = require('./svg/SVGPrev');

var _SVGPrev2 = _interopRequireDefault(_SVGPrev);

var _SVGNext = require('./svg/SVGNext');

var _SVGNext2 = _interopRequireDefault(_SVGNext);

var _SVGExpandMore = require('./svg/SVGExpandMore');

var _SVGExpandMore2 = _interopRequireDefault(_SVGExpandMore);

var _SVGExpandLess = require('./svg/SVGExpandLess');

var _SVGExpandLess2 = _interopRequireDefault(_SVGExpandLess);

var _recompose = require('recompose');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _RTGTransition = require('./RTGTransition');

var _RTGTransition2 = _interopRequireDefault(_RTGTransition);

var _Button = require('./Button');

var _Button2 = _interopRequireDefault(_Button);

var _helperFunctions = require('./helperFunctions');

var _ = require('.');

var _reactSwipeable = require('react-swipeable');

var _reactSwipeable2 = _interopRequireDefault(_reactSwipeable);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

//implement acceleration
//write own swipeable with render props
//press for accelerated scroll
//center on select
//cure the 'freeze' bug

var interval = void 0;

var Accordion = function Accordion(_ref) {
  var externalSwipeableRef = _ref.externalSwipeableRef,
      showLog = _ref.showLog,
      noX = _ref.noX,
      noY = _ref.noY,
      height = _ref.height,
      swipeableProps = _ref.swipeableProps,
      children = _ref.children,
      width = _ref.width,
      renderButton = _ref.renderButton;

  var swipeableRef = externalSwipeableRef ? externalSwipeableRef : (0, _react.useRef)(null);

  var _useReducer = (0, _react.useReducer)(function (state, newState) {
    return (0, _extends3.default)({}, state, newState);
  }, {
    showLeft: false,
    showRight: false,
    showUp: false,
    showDown: false
  }),
      _useReducer2 = (0, _slicedToArray3.default)(_useReducer, 2),
      state = _useReducer2[0],
      setState = _useReducer2[1];

  var showLeft = state.showLeft,
      showRight = state.showRight,
      showUp = state.showUp,
      showDown = state.showDown;

  var handleNavButtons = function () {
    var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
      var containerElement;
      return _regenerator2.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              containerElement = swipeableRef.current && swipeableRef.current.element;


              showLog && console.log('// handleNavButtons // ', 'containerElement.scrollLeft', containerElement.scrollLeft, 'scrollWidth: ', containerElement.scrollWidth, 'clientWidth: ', containerElement.clientWidth, 'diff: ', containerElement.scrollWidth - containerElement.clientWidth, 'scrollTop: ', containerElement.scrollTop, 'scrollHeight: ', containerElement.scrollHeight, 'clientHeight: ', containerElement.clientHeight);

              if (!(containerElement.scrollLeft === 0 || containerElement.scrollWidth === containerElement.clientWidth)) {
                _context.next = 7;
                break;
              }

              _context.next = 5;
              return setState({ showLeft: false });

            case 5:
              _context.next = 10;
              break;

            case 7:
              if (!(containerElement.scrollLeft > 0)) {
                _context.next = 10;
                break;
              }

              _context.next = 10;
              return setState({ showLeft: true });

            case 10:
              if (!(containerElement.scrollLeft >= containerElement.scrollWidth - containerElement.clientWidth || containerElement.scrollWidth === containerElement.clientWidth)) {
                _context.next = 15;
                break;
              }

              _context.next = 13;
              return setState({ showRight: false });

            case 13:
              _context.next = 18;
              break;

            case 15:
              if (!(containerElement.scrollWidth >= containerElement.clientWidth)) {
                _context.next = 18;
                break;
              }

              _context.next = 18;
              return setState({ showRight: true });

            case 18:
              if (!(containerElement.scrollTop === 0 || containerElement.scrollHeight === containerElement.clientHeight)) {
                _context.next = 23;
                break;
              }

              _context.next = 21;
              return setState({ showUp: false });

            case 21:
              _context.next = 26;
              break;

            case 23:
              if (!(containerElement.scrollTop > 0)) {
                _context.next = 26;
                break;
              }

              _context.next = 26;
              return setState({ showUp: true });

            case 26:
              if (!(containerElement.scrollTop >= containerElement.scrollHeight - containerElement.clientHeight || containerElement.scrollHeight === containerElement.clientHeight)) {
                _context.next = 31;
                break;
              }

              _context.next = 29;
              return setState({ showDown: false });

            case 29:
              _context.next = 34;
              break;

            case 31:
              if (!(containerElement.scrollTop === 0)) {
                _context.next = 34;
                break;
              }

              _context.next = 34;
              return setState({ showDown: true });

            case 34:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, undefined);
    }));

    return function handleNavButtons() {
      return _ref2.apply(this, arguments);
    };
  }();
  (0, _react.useEffect)(function () {
    handleNavButtons();
    var containerElement = swipeableRef.current && swipeableRef.current.element;
    containerElement.addEventListener('scroll', handleNavButtons);
    window.addEventListener('resize', handleNavButtons);
    return function () {
      var containerElement = swipeableRef.current && swipeableRef.current.element;
      containerElement.removeEventListener('scroll', handleNavButtons);
      window.removeEventListener('resize', handleNavButtons);
    };
  }, [children]);

  var startScroll = function startScroll(e, direction) {
    e.stopPropagation();
    clearInterval(interval);

    var containerElement = swipeableRef.current && swipeableRef.current.element;

    if (containerElement) {
      interval = setInterval(function () {
        switch (direction) {
          case 'left':
            containerElement.scrollLeft -= 20;
            break;

          case 'right':
            containerElement.scrollLeft += 20;
            break;

          case 'up':
            containerElement.scrollTop += -20;
            break;

          case 'down':
            containerElement.scrollTop += 20;
            break;
        }
      }, 50);
    }
  };
  var scroll = function scroll(e, direction) {
    e.stopPropagation();
    var containerElement = swipeableRef.current && swipeableRef.current.element;
    if (containerElement) {
      switch (direction) {
        case 'left':
          containerElement.scrollLeft -= 10;
          break;
        case 'right':
          containerElement.scrollLeft += 10;
          break;
        case 'up':
          containerElement.scrollTop -= 10;
          break;
        case 'down':
          containerElement.scrollTop += 10;
          break;
      }
    }
  };
  var endScroll = function endScroll(e) {
    e.stopPropagation();
    clearInterval(interval);
  };
  var renderNav = function renderNav(direction) {
    var containerElement = swipeableRef.current && swipeableRef.current.element;

    showLog && console.log('containerElement: ', containerElement);

    var autoHeight = containerElement && containerElement.clientHeight;
    var autoWidth = 18;
    var vertWidth = containerElement && containerElement.clientWidth;
    var vertHeight = 18;

    var SVGProps = {
      fill: '#555',
      size: width ? width : autoWidth
    };
    var renderIcon = function renderIcon(_ref3) {
      var direction = _ref3.direction,
          props = (0, _objectWithoutProperties3.default)(_ref3, ['direction']);

      switch (direction) {
        case 'right':
          return _react2.default.createElement(_SVGNext2.default, (0, _extends3.default)({}, SVGProps, props));
        case 'left':
          return _react2.default.createElement(_SVGPrev2.default, (0, _extends3.default)({}, SVGProps, props));
        case 'up':
          return _react2.default.createElement(_SVGExpandLess2.default, (0, _extends3.default)({}, SVGProps, props));
        case 'down':
          return _react2.default.createElement(_SVGExpandMore2.default, (0, _extends3.default)({}, SVGProps, props));
      }
    };
    var inProp = function inProp(_ref4) {
      var direction = _ref4.direction;

      switch (direction) {
        case 'right':
          return showRight;
        case 'left':
          return showLeft;
        case 'up':
          return showUp;
        case 'down':
          return showDown;
      }
    };
    var getStyle = function getStyle(_ref5) {
      var direction = _ref5.direction;

      switch (direction) {
        case 'right':
          return {
            top: 0,
            width: width ? width : autoWidth,
            height: height ? height : autoHeight,
            right: 0
          };
        case 'left':
          return {
            top: 0,
            width: width ? width : autoWidth,
            height: height ? height : autoHeight
          };
        case 'up':
          return {
            top: 0,
            width: width ? width : vertWidth,
            height: height ? height : vertHeight
          };
        case 'down':
          return {
            bottom: 0,
            width: width ? width : vertWidth,
            height: height ? height : vertHeight
          };
      }
    };
    return _react2.default.createElement(
      _RTGTransition2.default,
      { in: inProp({ direction: direction }) },
      function (_ref6) {
        var transitionStyle = _ref6.style;

        var getButtonProps = function getButtonProps() {
          var _ref7 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

          var style = _ref7.style,
              colors = _ref7.colors,
              props = (0, _objectWithoutProperties3.default)(_ref7, ['style', 'colors']);
          return {
            onMouseDown: function onMouseDown(e) {
              return startScroll(e, direction);
            },
            onMouseUp: endScroll,
            onTouchStart: function onTouchStart(e) {
              return startScroll(e, direction);
            },
            onTouchEnd: endScroll,
            className: 'accordion_navbutton accordion__navbutton--' + direction,
            colors: colors ? colors : _.buttonStyles.violet,
            style: (0, _extends3.default)({}, transitionStyle, {
              padding: 0,
              position: 'absolute'
            }, getStyle({ direction: direction }), style)
          };
        };
        return renderButton ? renderButton({ getButtonProps: getButtonProps, renderIcon: renderIcon, direction: direction }) : _react2.default.createElement(
          _Button2.default,
          (0, _extends3.default)({}, getButtonProps()),
          _react2.default.createElement(
            'div',
            { style: { background: '#fff' } },
            renderIcon({ direction: direction })
          )
        );
      }
    );
  };

  return typeof window !== 'undefined' && _react2.default.createElement(
    _react2.default.Fragment,
    null,
    !noX && renderNav('left'),
    !noY && renderNav('up'),
    _react2.default.createElement(
      _reactSwipeable2.default,
      (0, _extends3.default)({
        trackMouse: true,
        ref: swipeableRef,
        onSwiped: function onSwiped(e) {
          return endScroll(e);
        },
        onSwipingLeft: function onSwipingLeft(e, absX) {
          return scroll(e, 'left');
        },
        onSwipingRight: function onSwipingRight(e, absX) {
          return scroll(e, 'right');
        }
      }, swipeableProps),
      typeof children === 'function' ? children({ swipeableRef: swipeableRef }) : children
    ),
    !noX && renderNav('right'),
    !noY && renderNav('down')
  );
};

Accordion.defaultProps = {
  noX: false,
  noY: false,
  showLog: false
};

Accordion.propTypes = {
  containerClass: _propTypes2.default.string,

  width: _propTypes2.default.number
};

var enhance = (0, _recompose.compose)((0, _recompose.onlyUpdateForKeys)(['children']));

exports.default = enhance(Accordion);