'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _helperFunctions = require('./helperFunctions');

var _recompose = require('recompose');

var _OutsideClickListener = require('./OutsideClickListener');

var _OutsideClickListener2 = _interopRequireDefault(_OutsideClickListener);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var CTCGeneric = function CTCGeneric(_ref) {
  var pivotFrom = _ref.pivotFrom,
      _ref$switchOnHover = _ref.switchOnHover,
      switchOnHover = _ref$switchOnHover === undefined ? false : _ref$switchOnHover,
      _ref$useOCL = _ref.useOCL,
      useOCL = _ref$useOCL === undefined ? false : _ref$useOCL,
      children = _ref.children,
      isOn = _ref.isOn,
      setIsOnTo = _ref.setIsOnTo,
      toggleIsOn = _ref.toggleIsOn;

  var baseContainerStyle = {
    position: 'relative'
  };
  var getContainerProps = function getContainerProps() {
    var _ref2 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    var className = _ref2.className,
        style = _ref2.style,
        _onClick = _ref2.onClick,
        _onMouseEnter = _ref2.onMouseEnter,
        _onMouseLeave = _ref2.onMouseLeave,
        props = (0, _objectWithoutProperties3.default)(_ref2, ['className', 'style', 'onClick', 'onMouseEnter', 'onMouseLeave']);
    return (0, _extends3.default)({
      onClick: function onClick(e) {
        for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
          args[_key - 1] = arguments[_key];
        }

        e.stopPropagation();
        _onClick && _onClick.apply(undefined, [e].concat(args));
      },
      onMouseEnter: function onMouseEnter(e) {
        for (var _len2 = arguments.length, args = Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
          args[_key2 - 1] = arguments[_key2];
        }

        //e.stopPropagation()
        switchOnHover && setIsOnTo(true);
        _onMouseEnter && _onMouseEnter.apply(undefined, [e].concat(args));
      },
      onMouseLeave: function onMouseLeave(e) {
        for (var _len3 = arguments.length, args = Array(_len3 > 1 ? _len3 - 1 : 0), _key3 = 1; _key3 < _len3; _key3++) {
          args[_key3 - 1] = arguments[_key3];
        }

        //e.stopPropagation()
        switchOnHover && setIsOnTo(false);
        _onMouseLeave && _onMouseLeave.apply(undefined, [e].concat(args));
      },
      className: className ? (0, _helperFunctions.flippyClass)(isOn, 'ctcgeneric__container', 'on', 'off') + ' ' + className : (0, _helperFunctions.flippyClass)(isOn, 'ctcgeneric__container', 'on', 'off'),
      style: (0, _extends3.default)({}, baseContainerStyle, style)
    }, props);
  };

  var baseTriggerStyle = {
    cursor: 'pointer'
  };
  var getTriggerProps = function getTriggerProps() {
    var _ref3 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    var className = _ref3.className,
        _ref3$style = _ref3.style,
        style = _ref3$style === undefined ? {} : _ref3$style,
        _onClick2 = _ref3.onClick,
        props = (0, _objectWithoutProperties3.default)(_ref3, ['className', 'style', 'onClick']);
    return (0, _extends3.default)({
      onClick: function onClick(e) {
        for (var _len4 = arguments.length, args = Array(_len4 > 1 ? _len4 - 1 : 0), _key4 = 1; _key4 < _len4; _key4++) {
          args[_key4 - 1] = arguments[_key4];
        }

        e.stopPropagation();
        toggleIsOn();
        _onClick2 && _onClick2.apply(undefined, [e].concat(args));
      },
      className: className ? (0, _helperFunctions.flippyClass)(isOn, 'ctcgeneric__trigger', 'on', 'off') + ' ' + className : (0, _helperFunctions.flippyClass)(isOn, 'ctcgeneric__trigger', 'on', 'off'),
      style: (0, _extends3.default)({}, baseTriggerStyle, style)
    }, props);
  };

  var getChildrenStyle = function getChildrenStyle() {
    var shared = {
      position: 'absolute'
    };
    switch (pivotFrom) {
      case 'RIGHTDOWN':
        return (0, _extends3.default)({}, shared, { left: '100%', top: 0 });
      case 'LEFTDOWN':
        return (0, _extends3.default)({}, shared, { right: '100%', top: 0 });
      case 'UPRIGHT':
        return (0, _extends3.default)({}, shared, { bottom: '100%' });
      case 'UPLEFT':
        return (0, _extends3.default)({}, shared, { right: 0, bottom: '100%' });
      case 'DOWNLEFT':
        return (0, _extends3.default)({}, shared, { right: 0 });
      case 'DOWNRIGHT':
        return (0, _extends3.default)({}, shared, { left: 0 });
      default:
        return {};
    }
  };
  var getChildrenProps = function getChildrenProps() {
    var _ref4 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    var _onClick3 = _ref4.onClick,
        className = _ref4.className,
        style = _ref4.style,
        props = (0, _objectWithoutProperties3.default)(_ref4, ['onClick', 'className', 'style']);
    return (0, _extends3.default)({
      onClick: function onClick(e) {
        for (var _len5 = arguments.length, args = Array(_len5 > 1 ? _len5 - 1 : 0), _key5 = 1; _key5 < _len5; _key5++) {
          args[_key5 - 1] = arguments[_key5];
        }

        e.stopPropagation();
        _onClick3 && _onClick3.apply(undefined, [e].concat(args));
      },
      className: className ? (0, _helperFunctions.flippyClass)(isOn, 'ctcgeneric__children', 'on', 'hide') + ' ' + (className ? className : '') : (0, _helperFunctions.flippyClass)(isOn, 'ctcgeneric__children', 'on', 'hide'),
      style: (0, _extends3.default)({}, getChildrenStyle(), style)
    }, props);
  };

  var sharedProps = {
    getChildrenProps: getChildrenProps,
    getContainerProps: getContainerProps,
    getTriggerProps: getTriggerProps,
    isOn: isOn,
    setIsOnTo: setIsOnTo,
    toggleIsOn: toggleIsOn
  };
  var OCLRef = _react2.default.createRef();
  if (useOCL) {
    return _react2.default.createElement(
      _OutsideClickListener2.default,
      {
        containerRef: OCLRef,
        shouldCallHandler: isOn === true,
        handler: function handler() {
          return setIsOnTo(false);
        }
      },
      children((0, _extends3.default)({
        OCLRef: OCLRef
      }, sharedProps))
    );
  } else {
    return children((0, _extends3.default)({}, sharedProps));
  }
};

var enhance = (0, _recompose.compose)((0, _recompose.defaultProps)({
  switchOnHover: false,
  useOCL: false,
  connected: false
}), (0, _recompose.withStateHandlers)(function (_ref5) {
  var _ref5$openByDefault = _ref5.openByDefault,
      openByDefault = _ref5$openByDefault === undefined ? false : _ref5$openByDefault;
  return {
    isOn: openByDefault
  };
}, {
  toggleIsOn: function toggleIsOn(_ref6) {
    var isOn = _ref6.isOn;
    return function () {
      return { isOn: !isOn };
    };
  },
  setIsOnTo: function setIsOnTo() {
    return function (value) {
      return { isOn: value };
    };
  }
}), (0, _recompose.lifecycle)({
  componentDidUpdate: function componentDidUpdate() {
    var _props = this.props,
        connected = _props.connected,
        externalIsOn = _props.externalIsOn,
        isOn = _props.isOn,
        setIsOnTo = _props.setIsOnTo;

    if (connected === true) {
      if (isOn !== externalIsOn) {
        setIsOnTo(externalIsOn);
      }
    }
  }
}), (0, _recompose.onlyUpdateForKeys)(['externalIsOn', 'isOn', 'children']));

exports.default = enhance(CTCGeneric);